---

- name: Set facts
  ansible.builtin.set_fact:
    daemons:
      - openvpn

- name: Ensure monit package is present
  ansible.builtin.package:
    name: monit
    state: present
  when: ansible_system == 'Linux'
- name: Ensure monit configuration subdir is present
  ansible.builtin.file:
    dest: "{{ monit_confdir }}"
    state: directory
    mode: '0755'

- name: Debian
  block:
    - name: Set monit configurations
      ansible.builtin.template: "src={{ item }}-monit.j2 dest={{ monit_confdir }}/{{ item }} mode=0644 backup=yes"
      with_items: "{{ daemons }}"
      notify:
        - Restart monit
  when: ansible_distribution == 'Debian' or ansible_distribution == 'Ubuntu'

- name: RedHat
  block:
    - name: Set monit configurations
      ansible.builtin.template: "src={{ item }}-monit.j2 dest={{ monit_confdir }}/{{ item }} mode=0644 backup=yes"
      with_items: "{{ daemons }}"
      notify:
        - Restart monit
  when: ansible_os_family == "RedHat" or ansible_distribution == 'CentOS' or ansible_distribution == 'Red Hat Enterprise Linux'

- name: Allow monit status/summary from localhost
  ansible.builtin.replace:
    dest: "{{ monitrc }}"
    regexp: "{{ item.re }}"
    replace: "{{ item.rep }}"
    mode: '0644'
  with_items:
    - { re: '^# set httpd port 2812 and', rep: ' set httpd port 2812 and' }
    - { re: '^#    \s*use address localhost', rep: '     use address localhost' }
    - { re: '^#    \s*allow localhost', rep: '     allow localhost' }
    # - { re: '^#     allow admin:monit', rep: '     allow admin:monit' }
    - { re: '^#  include /etc/monit.d/*', rep: '  include /etc/monit.d/*' }
  notify:
    - Restart monit
    - Restart monit - darwin

- name: Linux | ensure monit service is enabled and started
  ansible.builtin.service: name=monit state=started enabled=yes
  when: ansible_system == 'Linux'
- name: Darwin | ensure monit service is enabled and started
  ansible.builtin.command: "launchctl load -w /Library/LaunchDaemons/org.macports.monit.plist"
  failed_when: false
  when: ansible_distribution == 'MacOSX'

- name: Flush handlers
  ansible.builtin.meta: flush_handlers
- include_tasks: monit-checkmonitor.yml
  vars:
    daemon: "{{ item }}"
  with_items: "{{ daemons }}"
